home *** CD-ROM | disk | FTP | other *** search
/ PC World 2000 February / PCWorld_2000-02_cd.bin / live / usr / lib / dpkg / methods / multicd / install < prev    next >
Text File  |  1999-02-08  |  8KB  |  283 lines

  1. #!/bin/sh
  2.  
  3. set -e
  4. vardir="$1"
  5. method=$2
  6. option=$3
  7.  
  8.  
  9. cd "$vardir/methods/$method"
  10.  
  11. . ./shvar.$option
  12.  
  13.  
  14. #debug() { echo "DEBUG: $@"; }
  15. debug() { true; }
  16. iarch=`dpkg --print-installation-architecture`
  17. ismulti() { test -e "$1/.disk/info" || test -e "$1$2/.disk/info"; }
  18. getdisklabel () {
  19.     debug "$1" "$2"
  20.     if [ -f $1/.disk/info ]
  21.     then
  22.     echo -n `head -1 "$1/.disk/info"`
  23.     else
  24.     echo -n `head -1 "$1$2/.disk/info"`
  25.     fi
  26. }
  27.  
  28. xit=1
  29.  
  30. do_umount() {
  31.     if [ "$method" = "multi_mount" ]
  32.     then
  33.         echo /bin/true
  34.         return
  35.     fi
  36.     if [ -n "$umount" ]; then
  37.         echo umount "$umount" 
  38.         #">/dev/null" "2>&1"
  39.     fi
  40. }
  41.  
  42. do_mount() {
  43.  
  44.     if [ "$method" = "multi_mount" ]
  45.     then
  46.         echo /bin/true
  47.         return
  48.     fi
  49.  
  50.     if [ ! -b "$p_blockdev" ]
  51.     then
  52.         loop=",loop"
  53.     fi
  54.  
  55.     if [ -n "$p_blockdev" ]
  56.     then
  57.         umount="$p_mountpoint"
  58.         echo mount -rt "$p_fstype" -o nosuid,nodev${loop} "$p_blockdev" "$p_mountpoint"\; umount="$p_mountpoint"
  59.     fi
  60.  
  61.     if [ -n "$p_nfs" ]
  62.     then
  63.         umount="$p_mountpoint"
  64.         echo mount -rt nfs "$p_nfs" -o nosuid,nodev "$p_mountpoint"\; umount="$p_mountpoint"
  65.     fi
  66.  
  67.     #if [ -n "$p_multi" -a -n "$p_multi_contentsfile" ]; then
  68.         #echo "This is disk "`getdisklabel "${p_mountpoint}" "${p_hierbase}"`
  69.     #fi
  70. }
  71.  
  72. trap 'eval `do_umount`; exit $xit' 0
  73.  
  74. eval `do_mount`
  75.  
  76. predep="$vardir/predep-package"
  77. while true
  78. do
  79.     thisdisk="`getdisklabel ${p_mountpoint} ${p_hierbase}`"
  80.     set +e
  81.     dpkg --predep-package >"$predep"
  82.     rc=$?
  83.     set -e
  84.     if test $rc = 1; then break; fi
  85.     test $rc = 0
  86.  
  87.     perl -e '
  88.         ($binaryprefix,$predep,$thisdisk) = @ARGV;
  89.         $binaryprefix =~ s,/*$,/, if length($binaryprefix);
  90.         open(P,"< $predep") || die "cannot open $predep: $!\n";
  91.         while (<P>) {
  92.             s/\s*\n$//;
  93.             $package= $_ if s/^Package: //i;
  94.             /^X-Medium:\s+(.*)\s*/ and $medium = $1;
  95.             @filename= split(/ /,$_) if s/^Filename: //i;
  96.             @msdosfilename= split(/ /,$_) if s/^MSDOS-Filename: //i;
  97.         }
  98.         length($package) || die "internal error - no package";
  99.         @filename || die "internal error - no filename";
  100.         @filename==@msdosfilename || !@filename || !@msdosfilename ||
  101.             die "internal error - mismatch >@filename< >@msdosfilename<";
  102.         if ($medium && ($medium ne $thisdisk)) {
  103.             print "
  104.  
  105. This is $thisdisk, but $package is expected on disk: $medium.
  106. Please change the disks and try again
  107.  
  108. ";
  109.             exit(1);
  110.         }
  111.         @invoke=(); $|=1;
  112.         for ($i=0; $i<=$#filename; $i++) {
  113.             $ppart= $i+1;
  114.             print "Looking for part $ppart of $package ... ";
  115.             if (-f "$binaryprefix$filename[$i]") {
  116.                 $print= $filename[$i];
  117.                 $invoke= "$binaryprefix$filename[$i]";
  118.             } elsif (-f "$binaryprefix$msdosfilename[$i]") {
  119.                 $print= $msdosfilename[$i];
  120.                 $invoke= "$binaryprefix$msdosfilename[$i]";
  121.             } else {
  122.                 $base= $filename[$i]; $base =~ s,.*/,,;
  123.                 $msdosbase= $msdosfilename[$i]; $msdosbase =~ s,.*/,,;
  124.                 defined($c= open(X,"-|")) ||
  125.                     die "failed to fork for find: $!\n";
  126.                 if (!$c) {
  127.                     exec("find", length($binaryprefix)
  128.                          ? $binaryprefix : ".","-follow",
  129.                          "-name",$base,"-o","-name",$msdosbase);
  130.                     die "failed to exec find: $!\n";
  131.                 }
  132.                 while (chop($invoke= <X>)) { last if -f $invoke; }
  133.                 $print= $invoke;
  134.                 if (substr($print,0,length($binaryprefix)+1) eq
  135.                     "$binaryprefix/") {
  136.                     $print= substr($print,length($binaryprefix));
  137.                 }
  138.             } 
  139.             if (!length($invoke)) {
  140.                 print STDERR "
  141.  
  142. Oh dear, I need to install or upgrade $package, but I don'\''t see
  143. the appropriate file(s) anywhere.  I'\''m expecting version $version or
  144. later, as that is listed in the Packages.cd file.
  145.  
  146. Perhaps you downloaded it with an unexpected name, or something.
  147. In any case, you must find the file(s) and then either place it with
  148. the correct filename(s) (as listed in the Packages.cd file or in
  149. /var/lib/dpkg/available) and rerun the installation, or upgrade the
  150. package by using `dpkg --install --auto-deconfigure'\'' by hand.
  151.  
  152. ";
  153.                 exit(1);
  154.             }
  155.             print "$print\n";
  156.             push(@invoke,$invoke);
  157.         }
  158.         print "Running dpkg -iB for $package ...\n";
  159.         exec("dpkg","-iB","--",@invoke);
  160.         die "failed to exec dpkg: $!\n";
  161.     ' -- "$p_mountpoint$p_main_binary" "$predep" "$thisdisk"
  162. done
  163.  
  164.     perl -e '
  165.     $SIG{INT} = sub { cd $vardir; unlink <tmp/*>; exit 1; };
  166.     $| = 1;
  167.     my ($vardir, $mountpoint, $hierbase, $mount, $umount) = @ARGV;
  168.     my $line;
  169.     my $AVAIL = "$vardir/methods/multicd/available";
  170.     my $STATUS = "$vardir/status";
  171.     my %Installed, %Filename, %Medium;
  172.     print "Get currently installed package versions...";
  173.     open(IN, "$STATUS") or die "Cannot open $STATUS: $!\n";
  174.     $line = 0;
  175.     { local $/ = "";
  176.     while (<IN>) {
  177.         my %status;
  178.         my @pstat;
  179.         $line++ % 20 or print ".";
  180.         s/\n\s+/ /g;
  181.         %status =  ("", split /^(\S*?):\s*/m, $_);
  182.         map { chomp $status{$_}; $status{$_} =~ s/^\s*(.*?)\s*$/$1/;} keys %status;
  183.         @pstat = split(/ /, $status{Status});
  184.         next unless ($pstat[0] eq "install");
  185.         if ($pstat[2] eq "config-files" || $pstat[2] eq "not-installed") {
  186.             $Installed{$status{Package}} = "0.0";
  187.         } else {
  188.             $Installed{$status{Package}} = $status{Version} || "" ;
  189.         }
  190.     }; }
  191.     print "\nGot ", scalar keys %Installed, " installed/pending packages\n";
  192.     print "Scanning available packages...";
  193.     $line = 0;
  194.     open(IN, "$AVAIL") or die("Cannot open $AVAIL: $!\n");
  195.     { local $/ = ""; 
  196.     while (<IN>) {
  197.         my $updated; 
  198.          $line++ % 20 or print ".";
  199.  
  200.          s/\n\s+/ /g;
  201.          %avail   =  ("", split /^(\S*?):\s*/m, $_);
  202.          map { chomp $avail{$_}; $avail{$_} =~ s/^\s*(.*?)\s*$/$1/;} keys %avail;
  203.  
  204.          next unless defined $Installed{$avail{Package}};
  205.  
  206.          system "dpkg", "--compare-versions", $avail{Version}, "gt", $Installed{$avail{Package}};
  207.          $updated = ($? == 0);
  208.          #print "$avail{Package}(" . ($updated ? "+" : "=") . ") "; 
  209.          $updated or next;
  210.  
  211.          $Filename{$avail{Package}} = $avail{Filename};
  212.  
  213.          next unless defined $avail{"X-Medium"};
  214.          ${Medium{$avail{"X-Medium"}}} or ${Medium{$avail{"X-Medium"}}} = [];
  215.          push @{${Medium{$avail{"X-Medium"}}}}, $avail{Package}; 
  216.     }; };
  217.     print "\n"; 
  218.  
  219.     if (@_ = keys(%Medium)) {
  220.         print "You will need the following distribution medium(s):\n",
  221.             join (", ", @_), "\n";
  222.     }
  223.  
  224.     foreach $need (sort @_) {
  225.         if (-r "$mountpoint/.disk/info") {
  226.             open(IN, "$mountpoint/.disk/info") or die("$mountpoint/.disk/info: $!\n");
  227.         } else {
  228.             open(IN, "$mountpoint/$hierbase/.disk/info") or die("$mountpoint/$hierbase/.disk/info: $!\n");
  229.         }
  230.         $disk = <IN>; chomp $disk; close(IN);
  231.  
  232.         print "Processing $need...";
  233.  
  234.         while ($disk ne $need) {
  235.             print "\nWrong disk.  I need \"$need\", but I found \"$disk\".\n",
  236.                   "Please change the disks and press <RETURN>\n";
  237.             system($umount);
  238.             <STDIN>;
  239.             system($mount); $? and warn("Cannot mount $mount\n");
  240.         } continue {
  241.             if (-r "$mountpoint/.disk/info") {
  242.                 open(IN, "$mountpoint/.disk/info") or die("$mountpoint/.disk/info: $!\n");
  243.             } else {
  244.                 open(IN, "$mountpoint/$hierbase/.disk/info") or die("$mountpoint/$hierbase/.disk/info: $!\n");
  245.             }
  246.             $disk = <IN>; chomp $disk; close(IN);
  247.         }
  248.  
  249.         -d "tmp" || mkdir "tmp", 0755 or die("Cannot mkdir tmp: $!\n");
  250.         unlink <tmp/*>;
  251.  
  252.         print "creating symlinks...\n";
  253.         foreach (@{$Medium{$need}}) {
  254.             ($basename = $Filename{$_}) =~ s/.*\///;
  255.             symlink "$mountpoint/$hierbase/$Filename{$_}", 
  256.                 "tmp/$basename";
  257.         }
  258.         chdir "tmp" or die "Cannot chdir to tmp: $!\n";
  259.         system "dpkg", "-iGROEB", ".";
  260.         unlink <*>;
  261.         chdir "..";
  262.  
  263.         if ($?) {
  264.             print "\nThe dpkg run produced errors.  Please tell me, if I should\n",
  265.                   "continue with the next CD. [Y/n]: ";
  266.             $ans = <STDIN>;
  267.             exit 1 if $ans =~ /^n/i;
  268.             $ouch = $?;
  269.         }
  270.     }
  271.  
  272.     exit $ouch;
  273.  
  274. ' "$vardir" "$p_mountpoint" "$p_hierbase" "`do_mount`" "`do_umount`"
  275.  
  276.  
  277. echo -n 'Installation OK.  Hit RETURN.  '
  278. read response
  279.  
  280. xit=0
  281.  
  282. # vim:ts=4:sw=4:aw:ai:
  283.